
/*------------------------------------------------------------
 *  Copyright 2002 By Marvin Tom and Guy Lemieux
 *
 * Permission to use, copy, and modify this software and its documentation is
 * hereby granted only under the following terms and conditions.  Both the
 * above copyright notice and this permission notice must appear in all copies
 * of the software, derivative works or modified versions, and any portions
 * thereof, and both notices must appear in supporting documentation.
 * Permission is granted ONLY for non-commercial use.  For
 * commercial use, please contact the authors.
 *
 * This software may be distributed (but not offered for sale or transferred
 * for compensation) to third parties, provided such third parties agree to
 * abide by the terms and conditions of this notice.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHORS, AS
 * WELL AS THE UNIVERSITY OF BRITISH COLUMBIA AND THE
 * UNIVERSITY OF TORONTO DISCLAIM ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL THE
 * AUTHORS OR THE UNIVERSITY OF BRITISH COLUMBIA OR THE
 * UNIVERSITY OF TORONTO BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *------------------------------------------------------------*/

//void free_clustering_depth_optimal()
//struct s_NDPoint* find_NDPoint_with_closest_arrival_time(int *atime_target, int block_num);
void alloc_and_load_cluster_info_depth_optimal (int ***cluster_contents_ptr,
        int **cluster_occupancy_ptr, int ***cluster_roots_ptr, int cluster_size, int *num_clusters,
		int ***block_in_cluster_w_arrival_ptr, int **num_clusters_block_in_ptr, int* max_arrival_time,
		int inputs_per_cluster, int lut_size);

void depth_optimal_cluster (int cluster_size, int inputs_per_cluster, int lut_size);
void cluster_consolidate(int **cluster_contents, int *cluster_occupancy, int **cluster_roots, struct s_coord *cluster_coords,
							int cluster_size, int *num_clusters_ptr, int lut_size, int inputs_per_cluster,
							int **block_in_cluster_w_arrival, int *num_clusters_block_in, int max_arrival_time);

